/*!
 * MediaElement.js
 * http://www.mediaelementjs.com/
 *
 * Wrapper that mimics native HTML5 MediaElement (audio and video)
 * using a variety of technologies (pure JavaScript, Flash, iframe)
 *
 * Copyright 2010-2017, John Dyer (http://j.hn/)
 * License: MIT
 *
 */
!function e(a,r,s){function t(o,n){if(!r[o]){if(!a[o]){var d="function"==typeof require&&require;if(!n&&d)return d(o,!0);if(i)return i(o,!0);var l=new Error("Cannot find module '"+o+"'");throw l.code="MODULE_NOT_FOUND",l}var p=r[o]={exports:{}};a[o][0].call(p.exports,function(e){var r=a[o][1][e];return t(r||e)},p,p.exports,e,a,r,s)}return r[o].exports}for(var i="function"==typeof require&&require,o=0;o<s.length;o++)t(s[o]);return t}({1:[function(e,a,r){"use strict";mejs.i18n.en["mejs.ad-skip"]="Skip ad",mejs.i18n.en["mejs.ad-skip-info"]=["Skip in 1 second","Skip in %1 seconds"],Object.assign(mejs.MepDefaults,{adsPrerollMediaUrl:[],adsPrerollAdUrl:[],adsPrerollAdEnableSkip:!1,adsPrerollAdSkipSeconds:-1,indexPreroll:0}),Object.assign(MediaElementPlayer.prototype,{adsLoaded:!1,adsDataIsLoading:!1,adsCurrentMediaUrl:"",adsCurrentMediaDuration:0,adsPlayerHasStarted:!1,buildads:function(e,a,r){var s=this;s.adsLoaded||(s.adsLoaded=!0,e.adsLayer=document.createElement("div"),e.adsLayer.className=s.options.classPrefix+"layer "+s.options.classPrefix+"overlay "+s.options.classPrefix+"ads",e.adsLayer.innerHTML='<a href="#" target="_blank"></a><div class="'+s.options.classPrefix+'ads-skip-block"><span class="'+s.options.classPrefix+'ads-skip-message"></span><span class="'+s.options.classPrefix+'ads-skip-button">'+mejs.i18n.t("mejs.ad-skip")+"</span></div>",e.adsLayer.style.display="none",r.insertBefore(e.adsLayer,r.querySelector("."+s.options.classPrefix+"overlay-play")),e.adsLayer.querySelector("a").addEventListener("click",s.adsAdClick.bind(s)),e.adsSkipBlock=e.adsLayer.querySelector("."+s.options.classPrefix+"ads-skip-block"),e.adsSkipBlock.style.display="none",e.adsSkipMessage=e.adsLayer.querySelector("."+s.options.classPrefix+"ads-skip-message"),e.adsSkipMessage.style.display="none",e.adsSkipButton=e.adsLayer.querySelector("."+s.options.classPrefix+"ads-skip-button"),e.adsSkipButton.addEventListener("click",s.adsSkipClick.bind(s)),s.adsMediaTryingToStartProxy=s.adsMediaTryingToStart.bind(s),s.adsPrerollStartedProxy=s.adsPrerollStarted.bind(s),s.adsPrerollMetaProxy=s.adsPrerollMeta.bind(s),s.adsPrerollUpdateProxy=s.adsPrerollUpdate.bind(s),s.adsPrerollVolumeProxy=s.adsPrerollVolume.bind(s),s.adsPrerollEndedProxy=s.adsPrerollEnded.bind(s),s.media.addEventListener("play",s.adsMediaTryingToStartProxy),s.media.addEventListener("playing",s.adsMediaTryingToStartProxy),s.media.addEventListener("canplay",s.adsMediaTryingToStartProxy),s.media.addEventListener("loadedmetadata",s.adsMediaTryingToStartProxy),s.options.indexPreroll<s.options.adsPrerollMediaUrl.length&&s.adsStartPreroll())},adsMediaTryingToStart:function(){var e=this;e.adsDataIsLoading&&!e.media.paused&&e.media.pause(),e.adsPlayerHasStarted=!0},adsStartPreroll:function(){var e=this;e.media.addEventListener("loadedmetadata",e.adsPrerollMetaProxy),e.media.addEventListener("playing",e.adsPrerollStartedProxy),e.media.addEventListener("ended",e.adsPrerollEndedProxy),e.media.addEventListener("timeupdate",e.adsPrerollUpdateProxy),e.media.addEventListener("volumechange",e.adsPrerollVolumeProxy),0===e.options.indexPreroll&&(e.adsCurrentMediaUrl=e.media.originalNode.getAttribute("src"),e.adsCurrentMediaDuration=e.media.duration),e.media.setSrc(e.options.adsPrerollMediaUrl[e.options.indexPreroll]),e.media.load();for(var a=e.container.querySelector("."+e.options.classPrefix+"controls").children,r=0,s=a.length;r<s;r++){var t=a[r],i=t.querySelector("button");i&&!mejs.Utils.hasClass(t,e.options.classPrefix+"playpause-button")?(i.disabled=!0,t.style.pointerEvents="none"):t.querySelector("."+e.options.classPrefix+"time-slider")&&(t.querySelector("."+e.options.classPrefix+"time-slider").style.pointerEvents="none")}e.adsPlayerHasStarted&&setTimeout(function(){e.media.play()},100)},adsPrerollMeta:function(){var e=this,a=0;e.options.duration>0?a=e.options.duration:isNaN(e.adsCurrentMediaDuration)||(a=e.adsCurrentMediaDuration),e.controls.querySelector("."+e.options.classPrefix+"duration")&&setTimeout(function(){e.controls.querySelector("."+e.options.classPrefix+"duration").innerHTML=mejs.Utils.secondsToTimeCode(a,e.options.alwaysShowHours,e.options.showTimecodeFrameCount,e.options.framesPerSecond,e.options.secondsDecimalLength)},250);var r=mejs.Utils.createEvent("mejsprerollinitialized",e.container);e.container.dispatchEvent(r)},adsPrerollStarted:function(){var e=this;e.media.removeEventListener("playing",e.adsPrerollStartedProxy),e.adsLayer.style.display="block",e.options.adsPrerollAdUrl[e.options.indexPreroll]?e.adsLayer.querySelector("a").href=e.options.adsPrerollAdUrl[e.options.indexPreroll]:(e.adsLayer.querySelector("a").href="#",e.adsLayer.querySelector("a").setAttribute("target","")),e.options.adsPrerollAdEnableSkip?(e.adsSkipBlock.style.display="block",e.options.adsPrerollAdSkipSeconds>0?(e.adsSkipMessage.innerHTML=mejs.i18n.t("mejs.ad-skip-info",e.options.adsPrerollAdSkipSeconds),e.adsSkipMessage.style.display="block",e.adsSkipButton.style.display="none"):(e.adsSkipMessage.style.display="none",e.adsSkipButton.style.display="block")):e.adsSkipBlock.style.display="none";var a=mejs.Utils.createEvent("mejsprerollstarted",e.container);e.container.dispatchEvent(a)},adsPrerollUpdate:function(){var e=this;e.options.adsPrerollAdEnableSkip&&e.options.adsPrerollAdSkipSeconds>0&&(e.media.currentTime>e.options.adsPrerollAdSkipSeconds?(e.adsSkipButton.style.display="block",e.adsSkipMessage.style.display="none"):e.adsSkipMessage.innerHTML=mejs.i18n.t("mejs.ad-skip-info",Math.round(e.options.adsPrerollAdSkipSeconds-e.media.currentTime)));var a=mejs.Utils.createEvent("mejsprerolltimeupdate",e.container);a.detail.duration=e.media.duration,a.detail.currentTime=e.media.currentTime,e.container.dispatchEvent(a)},adsPrerollVolume:function(){var e=this,a=mejs.Utils.createEvent("mejsprerollvolumechanged",e.container);e.container.dispatchEvent(a)},adsPrerollEnded:function(){var e=this;e.media.removeEventListener("ended",e.adsPrerollEndedProxy),setTimeout(function(){++e.options.indexPreroll<e.options.adsPrerollMediaUrl.length?e.adsStartPreroll():e.adRestoreMainMedia();var a=mejs.Utils.createEvent("mejsprerollended",e.container);e.container.dispatchEvent(a)},0)},adRestoreMainMedia:function(){var e=this;e.media.setSrc(e.adsCurrentMediaUrl),setTimeout(function(){e.media.load(),e.media.play()},10);for(var a=e.container.querySelector("."+e.options.classPrefix+"controls").children,r=0,s=a.length;r<s;r++){var t=a[r],i=t.querySelector("button");i&&!mejs.Utils.hasClass(t,e.options.classPrefix+"playpause-button")?(t.style.pointerEvents="auto",i.disabled=!1):t.querySelector("."+e.options.classPrefix+"time-slider")&&(t.querySelector("."+e.options.classPrefix+"time-slider").style.pointerEvents="auto")}e.adsSkipBlock&&e.adsSkipBlock.remove(),e.adsLayer.style.display="none",e.media.removeEventListener("ended",e.adsPrerollEndedProxy),e.media.removeEventListener("loadedmetadata",e.adsPrerollMetaProxy),e.media.removeEventListener("timeupdate",e.adsPrerollUpdateProxy);var o=mejs.Utils.createEvent("mejsprerollmainstarted",e.container);e.container.dispatchEvent(o)},adsAdClick:function(){var e=this;e.media.paused?e.media.play():e.media.pause();var a=mejs.Utils.createEvent("mejsprerolladsclicked",e.container);e.container.dispatchEvent(a)},adsSkipClick:function(e){var a=this;a.media.removeEventListener("ended",a.adsPrerollEndedProxy);var r=mejs.Utils.createEvent("mejsprerollskipclicked",a.container);a.container.dispatchEvent(r),r=mejs.Utils.createEvent("mejsprerollended",a.container),a.container.dispatchEvent(r),++a.options.indexPreroll<a.options.adsPrerollMediaUrl.length?a.adsStartPreroll():a.adRestoreMainMedia(),e.preventDefault(),e.stopPropagation()},prerollAdsFinished:function(){var e=this;return e.options.indexPreroll===e.options.adsPrerollMediaUrl.length},adsLoadUrl:function(e){var a=new Image,r=Math.round(1e5*Math.random());a.src=e+(~e.indexOf("?")?"&":"?")+"random"+r+"="+r,a.loaded=function(){a=null}}})},{}]},{},[1]);